package org.spring4d;

import org.sonar.plugins.communitydelphi.api.check.CheckRegistrar;
import org.sonar.plugins.communitydelphi.api.check.MetadataResourcePath;
import org.sonar.plugins.communitydelphi.api.check.ScopeMetadataLoader;

public class SpringDelphiCheckRegistrar implements CheckRegistrar {
  private final MetadataResourcePath metadataResourcePath;

  public SpringDelphiCheckRegistrar(MetadataResourcePath metadataResourcePath) {
    this.metadataResourcePath = metadataResourcePath;
  }

  @Override
  public void register(RegistrarContext registrarContext) {
    ScopeMetadataLoader scopeMetadataLoader =
        new ScopeMetadataLoader(metadataResourcePath, getClass().getClassLoader());

    registrarContext.registerClassesForRepository(
        RulesList.REPOSITORY_KEY, RulesList.getChecks(), scopeMetadataLoader::getScope);
  }
}
