package org.spring4d;

import static org.assertj.core.api.Assertions.*;
import static org.mockito.ArgumentMatchers.any;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;

import au.com.integradev.delphi.check.CheckRegistrarContextImpl;
import org.junit.jupiter.api.Test;
import org.sonar.plugins.communitydelphi.api.check.CheckRegistrar;
import org.sonar.plugins.communitydelphi.api.check.MetadataResourcePath;

class SpringDelphiCheckRegistrarTest {
  @Test
  void testRegister() {
    MetadataResourcePath metadataResourcePath = mock();
    when(metadataResourcePath.forRepository(any()))
        .thenReturn("org/sonar/l10n/delphi/rules/spring-delphi");

    CheckRegistrar registrar = new SpringDelphiCheckRegistrar(metadataResourcePath);
    var context = new CheckRegistrarContextImpl();

    registrar.register(context);

    assertThat(context.repositoryKey()).isEqualTo(RulesList.REPOSITORY_KEY);
    assertThat(context.checkClasses()).isEqualTo(RulesList.getChecks());
  }
}
