package org.spring4d;

import static org.assertj.core.api.Assertions.*;
import static org.mockito.ArgumentMatchers.any;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;

import org.junit.jupiter.api.Test;
import org.sonar.api.SonarEdition;
import org.sonar.api.SonarQubeSide;
import org.sonar.api.SonarRuntime;
import org.sonar.api.internal.SonarRuntimeImpl;
import org.sonar.api.server.rule.RulesDefinition;
import org.sonar.api.server.rule.RulesDefinition.Context;
import org.sonar.api.server.rule.RulesDefinition.Repository;
import org.sonar.api.utils.Version;
import org.sonar.plugins.communitydelphi.api.check.MetadataResourcePath;

class SpringDelphiRulesDefinitionTest {
  @Test
  void testDefine() {
    SonarRuntime runtime =
        SonarRuntimeImpl.forSonarQube(
            Version.create(1, 0), SonarQubeSide.SCANNER, SonarEdition.COMMUNITY);
    MetadataResourcePath metadataResourcePath = mock();
    when(metadataResourcePath.forRepository(any()))
        .thenReturn("/org/sonar/l10n/delphi/rules/spring-delphi");

    RulesDefinition rulesDefinition = new SpringDelphiRulesDefinition(runtime, metadataResourcePath);
    RulesDefinition.Context context = new Context();

    rulesDefinition.define(context);

    Repository repository = context.repository(RulesList.REPOSITORY_KEY);
    assertThat(repository).isNotNull();
    assertThat(repository.rules()).hasSameSizeAs(RulesList.getChecks());
  }
}
